/* 
 * bbskel.h
 *
 * The file contains the b&b template and what refers 
 * to the parallelism and the queue support.
 * Author: Casiano Rodriguez Leon. Email: casiano@ull.es
 * March, 1999
*/

#define MAXHEAPSIZE 16 

/*heap maintenance variables */ 
sh problemt problems[MAXHEAPSIZE];
sh index nP; /* number of problems in the heap */

sh index head = 0, tail = 0;
#define ADD(a,b) ((a+b) % MAXHEAPSIZE)
#define SUB(a,b) ((a+(MAXHEAPSIZE-b))% MAXHEAPSIZE)
sh error = 0;

/* variables for parallel computing */
sh int NUMPROCESSORS;

sync index numProblems(void) { /* number of problems in the queue */
  return (SUB(tail,head));
}

sync void getProblem(problemt *Prob) {

	farm setProblem(Prob, 
			problems[ADD(head,$)].k, 
			problems[ADD(head,$)].C, 
			problems[ADD(head,$)].P);

	NUMPROCESSORS = 0;
	$ = mpadd(&NUMPROCESSORS,1);
  if ($ == 0) {
		head = ADD(head,NUMPROCESSORS);
		farm printf("\n getting %d problems head = %d, tail = %d",
								NUMPROCESSORS,head,tail);
		farm printf("[%d]: getting problem (%d, %d, %d)\n", $, problems[head+$].k, problems[head+$].C, problems[head+$].P);
	}
}

sync void insertProblem(problemt Prob) {
  index next;

	NUMPROCESSORS = 0;
	$ = mpadd(&NUMPROCESSORS,1);
  next = ADD(tail,NUMPROCESSORS);
  
  if ((numProblems()+NUMPROCESSORS) >= MAXHEAPSIZE) seq { 
	 printf("\n[%d]:Error. The heap of problems is full.",$);
	 printf("\n[%d]: head = %d tail = %d",$,head,tail);
	 printf("\nIncrease the value of MAXHEAPSIZE. Current value is (%d)\n",MAXHEAPSIZE);
		error = 1; 
		exit (1);
  }
  farm setProblem(&problems[ADD(tail,$)],Prob.k, Prob.C, Prob.P);
  if ($ == 0) {
		tail = next;
	  farm printf("\n[%d]: inserting %d items, head = %d tail = %d",$,NUMPROCESSORS, head,tail);
	farm printf("[%d]: inserted problem (%d, %d, %d)\n", $, Prob.k, Prob.C, Prob.P);
	}
}

sync void branchAndBound(void) {
  problemt Prob, Probk;
  index nC, k;
	number L, U;

  farm if ($ == 0) printf("\n starting b&b ...");

	NUMPROCESSORS = 0;
	$ = mpadd(&NUMPROCESSORS,1);
  while ((nP = numProblems()) > 0) {
    farm if ($ == 0) printf("\n inside while nP > 0 ...");
    farm if ($ == 0) printf("\n NUMPROCESSORS = %d",NUMPROCESSORS);
		if ($ < nP) {
		 getProblem(&Prob);
		 farm nC = numChildren(Prob);
		 if (nC != 0) { /* not a leaf */
			farm lowerUpper(Prob, &L, &U);
			if (bestSol < L) 
				mpmax(&bestSol,L);
			/* L <= bestSol <= U */
			if (bestSol < U) {
				for(k = 0; k < nC; k++) {
					farm setChild(&Probk, Prob, k);
					insertProblem(Probk);
				}
			}
		 } /* end nC != 0 */
		} /* end $ < nP */
  } /* end while */
}


