/* Libreras. */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>
#include <math.h>
#include <values.h>
#include <time.h>
#include <alloc.h>





/* Global Constant. */
#define MAX_N 50                   /* Nmero de nodos en la red = orden de la matriz. */
#define MAX_SIZE_N 50
#define LONGFICH 20


/* Data Types definition. */
typedef int arrn[MAX_N];                   /* Define arrn como un array de MAX_N enteros. */
typedef int arrnn[MAX_N][MAX_N];           /* Define una matriz de MAX_N por MAX_N enteros. */

/* Global Variables. */
int size;
arrnn w;
arrn route;
int N;
int tweight;




/*----------------------------Read in of files------------------------------*/
void leer ( char *nombre, float valor[][MAX_SIZE_N] , int N )
{
 int i , j, ch;
 float val;                                                  /* Auxiliary vaiable to store the value of costs and flows. */
 FILE *fnombre;
 fnombre = fopen ( nombre , "r" );
 if ( fnombre == NULL )
   printf ( "Error de apertura en el fichero %s .", nombre );
 for ( i = 0 ; i < N ; i++ ) {
	for ( j = 0 ; j < N ; j++ )
	  {
	fscanf ( fnombre , "%f" , &val );
	if ( j < N )
	  valor[i][j] = val;                                  /* valor[][] stores values of the respective file, cost and flow. */
	  }
	ch = fgetc(fnombre);
	while ((ch != '\n') && (ch != EOF)) ch = fgetc(fnombre);

 }
 fclose ( fnombre );
 return;
}
/*----------------------------Read in of files------------------------------*/

/*----------------------------------BABTSP----------------------------------*/
void babtsp()
{
 int i;
 int index;
 arrn backptr;
 arrn best;
 arrn col;
 arrn fwdptr;
 arrn row;

 for ( i = 0 ; i < N ; i++ )
    {
     row[i] = i;
     col[i] = i;
     fwdptr[i] = 0;
     backptr[i] = 0;
    } /* for i... */
 tweight = MAXINT;

 explore ( 0 , 0 , row , col );

 index = 1;

 for ( i = 0 ; i < N ; i++ )
    {
     route[i] = index;
     index = best[index];
    } /* for i... */
} /* BABTSP. */
/*----------------------------------BABTSP----------------------------------*/


/*-----------------------------------MIN------------------------------------*/
int minimum( int i , int j )
{
 /* Calcula el mnimo de i y j. */
 if ( i <= j )
   return ( i );
 else
   return ( j );
} /* minimum... */

/*-----------------------------------MIN------------------------------------*/


/*----------------------------------REDUCE----------------------------------*/
int reduce ( arrn row , arrn col , arrn rowred , arrn colred )
{
 /* Calcula el elemento ms pequeo de cada fila y cada columna, con el que
    se puede reducir la matriz A sin que queden elementos negativos. */
 int i , j;                                       /* Contadores. */
 int rvalue;                                      /* Variable que guarda el valor de reduccin dentro de la rutina. */
 int temp;                                        /* Variable temporal para realizar clculos. */
 int reduce;                                      /* Valor de reduccin. */

 rvalue = 0;
 /* Se estudian las filas... */
 for ( i = 0 ; i < size ; i++ )
    {
     temp = MAXINT;
     /* Y dentro de cada fila, se calcula el mnimo. */
     for ( j = 0 ; j < size ; j++ )
	temp = minimum ( temp , w[row[i]][col[j]] );
     if ( temp > 0 )
       {
	for ( j = 0 ; j < size ; j++ )
	   if ( w[row[i]][col[j]] < MAXINT )
	     w[row[i]][col[j]] -= temp;
	rvalue += temp;
       } /* if... */
     rowred[i] = temp;
    } /* for i... */

 /* Se estudian las columnas... */
 for ( j = 0 ; j < size ; j++ )
    {
     temp = MAXINT;
     /* Y dentro de cada columna, se calcula el mnimo. */
     for ( i = 0 ; i < size ; i++ )
	temp = minimum ( temp , w[row[i]][col[j]] );
     if ( temp > 0 )
       {
	for ( i = 0 ; i < size ; i++ )
	   if ( w[row[i]][col[j]] < MAXINT )
	     w[row[i]][col[j]] -= temp;
	rvalue += temp;
       } /* if... */
     colred[j] = temp;
    } /* for j... */
 reduce = rvalue;
 return ( reduce );
} /* reduce... */
/*----------------------------------REDUCE----------------------------------*/

/*---------------------------------BESTEDGE---------------------------------*/
void bestedge ( int r , int c , int most )
{
 /* Calcula el mejor arco, de los restantes, a introducir en la ruta del
    cartero. */
 int i , j , k;                                   /* Contadores. */
 int mincolelt;
 int minrowelt;
 int zeroes;

 most = -MAXINT;

 for ( i = 0 ; i < size ; i++ )
    {
     for ( j = 0 ; j < size ; j++ )
	{
	 if ( w[i][j] == 0 )
	   {
	    minrowelt = MAXINT;
	    zeroes = 0;
	    for ( k = 0 ; k < size ; k++ )
	       {
		if ( w[i][k] == 0 )
		  zeroes = zeroes + 1;
		else
		  minrowelt = minimum ( minrowelt , w[i][k] );
	       } /* for k... */
	    if ( zeroes > 1 )
	      minrowelt = 0;

	    mincolelt = MAXINT;
	    zeroes = 0;
	    for ( k = 0 ; k < size ; k++ )
	       {
		if ( w[k][j] == 0 )
		  zeroes = zeroes + 1;
		else
		  mincolelt = minimum ( mincolelt , w[k][i] );
	       } /* for k... */
	    if ( zeroes > 1 )
	      mincolelt = 0;

	    if ( ( minrowelt + mincolelt ) > most )
	      {
	       most = minrowelt + mincolelt;
	       r = i;                             /* Indice de la fila del mejor arco. */
	       c = j;                             /* Indice de la columna del mejor arco. */
	      } /* if (min + ... )... */
	   } /* if... */
	} /* for j... */
    } /* for i... */
 return;
} /* bestedge. */
/*---------------------------------BESTEDGE---------------------------------*/





/*---------------------------------EXPLORE----------------------------------*/
void explore ( int edges , int cost , arrn row , arrn col )
{
 arrn backptr;
 arrn best;
 arrn fwdptr;


 int i , j;
 int avoid;
 int c;
 int colrowval;
 int first;
 int last;
 int lowerbound;
 int most;
 int r;
 int size;
 int val_reduce;                            /* Value of the reduction of matrix. */
 arrn colred;
 arrn newcol;
 arrn newrow;
 arrn rowred;


 size = N - edges;                        /* Number of rows, cols left in matrix. */

 val_reduce = reduce ( row , col , rowred , colred );

 cost = cost + val_reduce;

 if ( cost < tweight )
   {
    if ( edges = ( N - 2 ) )
      {
       for ( i = 0 ; i < N ; i++ )
	  {
	   best[i] = fwdptr[i];
	   if ( w[1][1] == MAXINT )
	     avoid = 1;
	   else
	     avoid = 2;
	   best[row[1]] = col[3 - avoid];
	   best[row[2]] = col[avoid];
	   tweight = cost;
	  } /* for... */
      } /* if edges... */
   } /* if cost... */
 else
   {
    bestedge ( r , c , most );
    lowerbound = cost + most;
    fwdptr[row[r]] = col[c];                /* Record chosen edge. */
    backptr[col[c]] = row[r];
    last = col[c];
    while ( fwdptr[last] != 0 )
	 last = fwdptr[last];
    first = row[r];
    while ( backptr[first] != 0 )
	 first = backptr[first];
    colrowval = w[last][first];
    for ( i = 0 ; i < ( r - 1 ) ; i++ )
       newrow[i] = row[i];
    for ( i = r ; i < ( size - 1 ) ; i++ )
       newrow[i] = row[i + 1];
    for ( i = 0 ; i < ( c - 1 ) ; i++ )
       newcol[i] = col[i];
    for ( i = c ; i < ( size - 1 ) ; i++ )
       newcol[i] = col[i + 1];

    explore ( edges + 1 , cost , newrow , newcol );

    w[last][first] = colrowval;
    backptr[col[c]] = 0;
    fwdptr[row[r]] = 0;

    if ( lowerbound < tweight )
      {
       w[r][c] = MAXINT;                      /* Exclude edge already chosen. */

       explore ( edges , cost , row , col );

       w[r][c] = 0 ;                          /* Restore escluded edge. */
      }/* if lowerbound... */

   } /* else cost... */

 for ( i = 0 ; i < size ; i++ )
    for ( j = 0 ; j < size ; j++ )
       w[i][j] += rowred[i] + colred[j];
} /* explore. */
/*---------------------------------EXPLORE----------------------------------*/



